<template>
    <div>
        <v-toolbar flat color="white">
            <v-toolbar-title>{{tableTitle}}</v-toolbar-title>
            <v-spacer></v-spacer>
            <UserNewEdit></UserNewEdit>
        </v-toolbar>
        <div>
            <v-data-table
                :headers="headers"
                :items="responseData"
                :pagination.sync="pagination"
                :total-items="meta.total"
                :loading="loading"
                class="elevation-1"
                :rows-per-page-items="[15,30,50,100,200,{'text':'$vuetify.dataIterator.rowsPerPageAll','value':-1}]"
            >
                <v-progress-linear v-slot:progress color="blue" indeterminate></v-progress-linear>
                <template v-slot:items="props">
                    <td v-for="header in headers">{{ props.item[header.value] }}</td>
                    <td>
                        <UserNewEdit :user="props.item"></UserNewEdit>
                        <v-icon
                            small
                            @click="deleteRow(props.item)"
                        >
                            delete
                        </v-icon>
                        <Roles :user-id="props.item.id"></Roles>
                    </td>
                </template>
            </v-data-table>
        </div>
    </div>

</template>
<script>
    import helpers from './../../helpers';
    import UserNewEdit from './UserNewEdit';
    import Roles from './Roles';

    export default {
        components: {
            UserNewEdit,
            Roles
        },
        data() {
            return {
                model: '',
                meta: {},
                responseData: [],
                loading: true,
                pagination: {},
                headers: [],
            }
        },
        computed: {
            tableTitle() {
                return this.$route.name.charAt(0).toUpperCase() + this.$route.name.slice(1);
            }
        },
        watch: {
            pagination: {
                handler() {
                    this.fetchData();
                },
                deep: true
            },
        },
        created() {
            this.fetchData();
        },
        methods: {
            fetchData: function () {
                this.loading = true;
                this.model = this.$router.currentRoute.path;
                const {sortBy, descending, page, rowsPerPage} = this.pagination;
                axios.get(this.model, {
                    params: {
                        sort_by: this.pagination.sortBy,
                        descending: this.pagination.descending,
                        page: this.pagination.page,
                        rows_per_page: this.pagination.rowsPerPage,
                    }
                })
                    .then(response => {
                        this.loading = false;
                        this.meta = response.data.meta;
                        this.pagination.rowsPerPage = response.data.meta.per_page;
                        this.responseData = response.data.data;
                        this.createHeaders();

                    })
                    .catch(error => {
                        this.meta = {};
                        this.responseData = [];
                        this.headers = [];
                        helpers.errorHandler(error);
                    });
            },
            createHeaders() {
                this.headers = [];
                if (this.responseData.lenght <= 0) {
                    return;
                }
                for (let item in this.responseData[0]) {
                    let text = item.charAt(0).toUpperCase() + item.slice(1);
                    this.headers.push({
                        text: text.split('_').join(' '),
                        value: item
                    });
                }
            },
            deleteRow: function (user) {
                confirm('Are you sure you want to delete this user?') && axios.delete(this.model + '/' + user.id)
                    .then(response => {
                        this.responseData = this.responseData.filter(el => el.id !== response.data.id);
                    })
                    .catch(error => helpers.errorHandler(error));
            }
        }
    }
</script>

